Description

Request IDs can be added to Foreman's logs to make it easier to trace all log messages relating to a particular request when they

interleave from multiple server processes.

Rails stores an ID in the request environment by default, and since Rails 5, the default configuration is to log it. The request ID is

derived from the X-Request-ID header, otherwise a random UUID. Since Foreman uses the logging gem without tagging support

instead of the default Rails logger, implementing this requires passing the extra information to its MDC/NDC (context) storage.

Related issues:

Related to Foreman - Feature #15876: Send request and session ids to foreman-... Duplicate 07/28/2016

Related to Foreman - Feature #10982: Add logging to smart proxy requests (Pro... Closed 07/02/2015

Related to Foreman - Bug #19017: Use request id instead of session id of tagg... Closed 03/24/2017

Associated revisions

Revision d97deb49 - 07/28/2016 04:24 AM - Dominic Cleal

fixes #15863 - add short session or request ID to logs

New middleware stores the session and request IDs (either from

X-Request-ID or a UUID generated by Rails) in the logger's thread

storage. The truncated session ID is now logged by default to minimise

size of the log messages.

History

#1 - 07/27/2016 10:41 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3678 added

#2 - 07/28/2016 05:02 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset d97deb49dc07939998565bec0cef582082a8d91d.

#3 - 07/28/2016 07:48 AM - Lukas Zapletal

- Related to Feature #15876: Send request and session ids to foreman-proxy as HTTP headers added

#4 - 07/28/2016 07:51 AM - Dominic Cleal

- Related to Feature #10982: Add logging to smart proxy requests (ProxyAPI) added

#5 - 07/29/2016 07:19 AM - Dominic Cleal

- translation missing: en.field_release set to 160
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/d97deb49dc07939998565bec0cef582082a8d91d


#6 - 03/24/2017 05:00 AM - Ivan Necas

- Bugzilla link set to 1435563

#7 - 03/24/2017 07:42 AM - Ivan Necas

- Related to Bug #19017: Use request id instead of session id of tagged logging added
